CONST VER$ = "1.3"
DECLARE SUB Save (lngByte AS LONG, strData AS STRING)
DECLARE FUNCTION Word$ (lngNum AS LONG)
DECLARE FUNCTION Sum$ (strInOut AS STRING)

DIM SHARED lngChkSum
DIM strFile AS STRING
DIM strData AS STRING
DIM lngDataLen AS LONG

strFile = UCASE$(LTRIM$(RTRIM$(COMMAND$)))

PRINT
PRINT "QPack v" + VER + " - By Paul Marks [paul248@techie.com]"
PRINT "Converts BIN Files To TI-83+ Program Files (8XP)."
PRINT
COLOR 12

IF strFile = "" THEN
   GOTO Usage
END IF

OPEN strFile + ".BIN" FOR BINARY ACCESS READ AS #1
   lngDataLen = LOF(1)
   IF lngDataLen = 0 THEN
      PRINT "Unable To Open "; strFile; ".BIN !!!"
      GOTO Usage
   END IF
   strData = STRING$(lngDataLen, 0)
   GET 1, , strData
CLOSE 1

OPEN strFile + ".8XP" FOR OUTPUT AS #1: CLOSE 1
OPEN strFile + ".8XP" FOR BINARY ACCESS WRITE AS #1
   lngChkSum = -1
   Save (&H0), "**TI83F*"
   Save (&H8), CHR$(&H1A) + CHR$(&HA) + CHR$(&H0)
   Save (&HB), "File Generated With QPack v" + VER + " By Paul Marks"
   Save (&H35), Word$(lngDataLen + 19)
  
   lngChkSum = 0
   Save (&H37), CHR$(&HD) + CHR$(&H0)
   Save (&H39), Word$(lngDataLen + 2)
   Save (&H3B), CHR$(&H6)
   Save (&H3C), strFile
   Save (&H46), Word$(lngDataLen + 2)
   Save (&H48), Word$(lngDataLen)
   Save (&H4A), strData
   Save (&H4A + lngDataLen), Word$(lngChkSum AND &HFFFF&)
CLOSE 1

COLOR 10
PRINT strFile; ".8XP Created Successfully!"
COLOR 14
PRINT "Name: "; strFile
PRINT "Size:"; lngDataLen + 13; "Bytes"
END

Usage:
PRINT "Usage: QPack BINFILE (No Extention)"
END

SUB Save (lngByte AS LONG, strData AS STRING)
   IF lngChkSum <> -1 THEN
      DIM i AS INTEGER
      FOR i = 1 TO LEN(strData)
         lngChkSum = lngChkSum + ASC(MID$(strData, i, 1))
      NEXT i
   END IF
   PUT 1, lngByte + 1, strData
END SUB

FUNCTION Sum$ (strInOut AS STRING)
END FUNCTION

FUNCTION Word$ (lngNum AS LONG)
   Word$ = CHR$(lngNum AND &HFF) + CHR$((lngNum AND &HFF00) / &H100)
END FUNCTION

